package sun.util.calendar;

import java.util.TimeZone;
import java.util.Locale;

class ImmutableGregorianDate extends BaseCalendar.Date
{
    private final BaseCalendar.Date date;
    
    ImmutableGregorianDate(BaseCalendar.Date date) {
        if (date == null) {
            throw new NullPointerException();
        }
        this.date = date;
        return;
    }
    
    @Override
    public Era getEra() {
        return this.date.getEra();
    }
    
    @Override
    public CalendarDate setEra(Era era) {
        this.unsupported();
        return this;
    }
    
    @Override
    public int getYear() {
        return this.date.getYear();
    }
    
    @Override
    public CalendarDate setYear(int n) {
        this.unsupported();
        return this;
    }
    
    @Override
    public CalendarDate addYear(int n) {
        this.unsupported();
        return this;
    }
    
    @Override
    public boolean isLeapYear() {
        return this.date.isLeapYear();
    }
    
    @Override
    void setLeapYear(boolean b) {
        this.unsupported();
    }
    
    @Override
    public int getMonth() {
        return this.date.getMonth();
    }
    
    @Override
    public CalendarDate setMonth(int n) {
        this.unsupported();
        return this;
    }
    
    @Override
    public CalendarDate addMonth(int n) {
        this.unsupported();
        return this;
    }
    
    @Override
    public int getDayOfMonth() {
        return this.date.getDayOfMonth();
    }
    
    @Override
    public CalendarDate setDayOfMonth(int n) {
        this.unsupported();
        return this;
    }
    
    @Override
    public CalendarDate addDayOfMonth(int n) {
        this.unsupported();
        return this;
    }
    
    @Override
    public int getDayOfWeek() {
        return this.date.getDayOfWeek();
    }
    
    @Override
    public int getHours() {
        return this.date.getHours();
    }
    
    @Override
    public CalendarDate setHours(int n) {
        this.unsupported();
        return this;
    }
    
    @Override
    public CalendarDate addHours(int n) {
        this.unsupported();
        return this;
    }
    
    @Override
    public int getMinutes() {
        return this.date.getMinutes();
    }
    
    @Override
    public CalendarDate setMinutes(int n) {
        this.unsupported();
        return this;
    }
    
    @Override
    public CalendarDate addMinutes(int n) {
        this.unsupported();
        return this;
    }
    
    @Override
    public int getSeconds() {
        return this.date.getSeconds();
    }
    
    @Override
    public CalendarDate setSeconds(int n) {
        this.unsupported();
        return this;
    }
    
    @Override
    public CalendarDate addSeconds(int n) {
        this.unsupported();
        return this;
    }
    
    @Override
    public int getMillis() {
        return this.date.getMillis();
    }
    
    @Override
    public CalendarDate setMillis(int n) {
        this.unsupported();
        return this;
    }
    
    @Override
    public CalendarDate addMillis(int n) {
        this.unsupported();
        return this;
    }
    
    @Override
    public long getTimeOfDay() {
        return this.date.getTimeOfDay();
    }
    
    @Override
    public CalendarDate setDate(int n, int n2, int n3) {
        this.unsupported();
        return this;
    }
    
    @Override
    public CalendarDate addDate(int n, int n2, int n3) {
        this.unsupported();
        return this;
    }
    
    @Override
    public CalendarDate setTimeOfDay(int n, int n2, int n3, int n4) {
        this.unsupported();
        return this;
    }
    
    @Override
    public CalendarDate addTimeOfDay(int n, int n2, int n3, int n4) {
        this.unsupported();
        return this;
    }
    
    @Override
    protected void setTimeOfDay(long n) {
        this.unsupported();
    }
    
    @Override
    public boolean isNormalized() {
        return this.date.isNormalized();
    }
    
    @Override
    public boolean isStandardTime() {
        return this.date.isStandardTime();
    }
    
    @Override
    public void setStandardTime(boolean b) {
        this.unsupported();
    }
    
    @Override
    public boolean isDaylightTime() {
        return this.date.isDaylightTime();
    }
    
    @Override
    protected void setLocale(Locale locale) {
        this.unsupported();
    }
    
    @Override
    public TimeZone getZone() {
        return this.date.getZone();
    }
    
    @Override
    public CalendarDate setZone(TimeZone timeZone) {
        this.unsupported();
        return this;
    }
    
    @Override
    public boolean isSameDate(CalendarDate calendarDate) {
        return calendarDate.isSameDate(calendarDate);
    }
    
    @Override
    public boolean equals(Object o) {
        return this == o || (o instanceof ImmutableGregorianDate && this.date.equals(((ImmutableGregorianDate)o).date));
    }
    
    @Override
    public int hashCode() {
        return this.date.hashCode();
    }
    
    @Override
    public Object clone() {
        return super.clone();
    }
    
    @Override
    public String toString() {
        return this.date.toString();
    }
    
    @Override
    protected void setDayOfWeek(int n) {
        this.unsupported();
    }
    
    @Override
    protected void setNormalized(boolean b) {
        this.unsupported();
    }
    
    @Override
    public int getZoneOffset() {
        return this.date.getZoneOffset();
    }
    
    @Override
    protected void setZoneOffset(int n) {
        this.unsupported();
    }
    
    @Override
    public int getDaylightSaving() {
        return this.date.getDaylightSaving();
    }
    
    @Override
    protected void setDaylightSaving(int n) {
        this.unsupported();
    }
    
    @Override
    public int getNormalizedYear() {
        return this.date.getNormalizedYear();
    }
    
    @Override
    public void setNormalizedYear(int n) {
        this.unsupported();
    }
    
    private void unsupported() {
        throw new UnsupportedOperationException();
    }
}
